<script>
  // Dimensions
  const width = 800;
  const height = 100;
  const margin = { top: 20, right: 5, bottom: 5, left: 5 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  
  // Array
  const values = [
    { x: 2, y: 1, category: "cat1" },
    { x: 4, y: 2, category: "cat3" },
    { x: 6, y: 1, category: "cat2" },
    { x: 7, y: 3, category: "cat3" },
    { x: 9, y: 1, category: "cat2" }
  ];
;
  import {scaleLinear} from 'd3-scale';
  import {schemeDark2 } from 'd3-scale-chromatic';
  import {axisBottom} from "d3-axis";
  import {select} from "d3-selection"
  const x = scaleLinear().domain([1,10]).range([0,innerWidth])
  const y = scaleLinear().domain([0,3]).range([innerHeight,0])
  let cat1 = schemeDark2[0]
  let cat2 = schemeDark2[1]
  let cat3 = schemeDark2[2]
  function color(cat)
  {
    if (cat == "cat1")
    {return cat1}
    else if (cat == "cat2")
    {return cat2}
    else 
    {return cat3}
  }
  function xAxis(element) 
  {
    let axis=axisBottom(x);
    select(element).call(axis);
  }
</script>

<svg viewBox="0 0 {width} {height}">
  <g transform="translate({margin.left},{margin.top})">
    {#each values as value}
      <circle r=5 cx = {x(value.x)} cy = {y(+value.y)} fill = {color(value.category)}/>
      <rect x={x(+value.x)} y={y(+value.y)+5} width="1" height={innerHeight-y(+value.y)-20}/>
    {/each}
    <text x={innerWidth/2} y={height-margin.top} fill = "currentcolor" style="font-size:0.75em;">x label </text>
    
  </g>
  <g transform="translate({margin.left},{innerHeight+5})" use:xAxis>
  </g>
</svg>

<style>
  text {
    text-anchor: middle;
    font-size: small;
  }
</style>
